unit Codepages;

interface
uses windows,messages,classes,sysutils;


function ConvertEncoding(sIn: string; sCoding: string): string;
//sIn -   
//sCoding -   
//result -   

function WinToDos(St: string): string;
function DosToWin(St: string): string;

function l3AnalizeCharSetBuf(Buf: PChar; Len: LongInt): Byte;
{  l3_csANSI = 0;  -  ANSII
   l3_csOEM = 255; -  OEM
}
procedure GetKLList(List: TStrings); //  

implementation



type //   
  TCodeMatrix = array[1..255] of char;
const //  
  FirstCodes =
    #1#2#3#4#5#6#7#8#9#10#11#12#13#14#15#16#17#18#19#20#21#22#23#24#25#26#27#28+
   #29#30#31' !"#$%&''()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^' +
    '_`abcdefghijklmnopqrstuvwxyz{|}~';
  cmAnsiToKoi8R: TCodeMatrix = FirstCodes // ver 1.0, VEG, 31.10.2003
  + ' '
    + '';
  cmAnsiToKoi8U: TCodeMatrix = FirstCodes // ver 0.8, VEG, 31.10.2003
  + ' '
    + '';
  cmKoi8RToAnsi: TCodeMatrix = FirstCodes // ver 1.0, VEG, 31.10.2003
  + '--L-++T++------?v??? ???=-㬬LLL---TTT+++'
    + '';
  cmKoi8UToAnsi: TCodeMatrix = FirstCodes // ver 1.0, VEG, 31.10.2003
  + '--L-++T++------?v??? ???=-㳿LLL-T+'
    + '';
  cmOemDosToAnsi: TCodeMatrix = FirstCodes // ver 1.0, VEG, 31.10.2003
  + '---+---L+T+-+L'
    + 'T=+TTLL-++-----v ';
  cmIsoToAnsi: TCodeMatrix = FirstCodes // ver 1.0, VEG, 31.10.2003
  + '??????????????????????????????? '
    + '';

function ConvertEncoding(sIn: string; sCoding: string): string;
//sIn -   
//sCoding -   
//result -   
var
  iFtd: integer;
begin
  for iFtd := 1 to length(sIn) do
    result := result + sCoding[ord(sIn[iFtd])];
end;

function WinToDos(St: string): string;
var
  Ch: PChar;
begin
  Ch := StrAlloc(Length(St) + 1);
  AnsiToOem(PChar(St), Ch);
  Result := Ch;
  StrDispose(Ch)
end;

function DosToWin(St: string): string;
var
  Ch: PChar;
begin
  Ch := StrAlloc(Length(St) + 1);
  OemToAnsi(PChar(St), Ch);
  Result := Ch;
  StrDispose(Ch)
end;

const
  l3_csANSI = 0;
  {-  ANSII}
  l3_csOEM = 255;
  {-  OEM}

type
  cc_Graph_CriteriaRange = #176..#223; {-   }
  TChars = set of char;
  Long = LongInt;

const
  cc_OEM_CriteriaEx = [#128..#175] + [#224..#239];
  cc_ANSI_CriteriaEx = [#192..#255];
  cc_Graph_Criteria = [Low(cc_Graph_CriteriaRange)..High(cc_Graph_CriteriaRange)];

type
  T_cc_GraphCounts = array [cc_Graph_CriteriaRange] of Longint;

procedure l3AnalizeCharSetEx(var Buf: PChar; BufEnd: PChar;
var OEMCount, ANSICount, GraphCount: Long;
var GraphCounts: T_cc_GraphCounts);
var
  C : Char;
begin
  OEMCount := 0;
  ANSICount := 0;
  GraphCount := 0;
  for C := Low(T_cc_GraphCounts) to High(T_cc_GraphCounts) do GraphCounts[C] := 0;
  while (Buf <  BufEnd) do begin
    C := Buf^;
    Inc(Buf);
    if (C in cc_OEM_CriteriaEx) then Inc(OEMCount);
    if (C in cc_ANSI_CriteriaEx) then Inc(ANSICount);
    if (C in cc_Graph_Criteria) then begin
      Inc(GraphCounts[C]);
      Inc(GraphCount);
    end;
  end;{Buf <  BufEnd}
end;

function l3AnalizeCharSetExEx(Buf, BufEnd: PChar): Byte;
var
  OEMCount : Long;
  ANSICount : Long;
  GraphCount : Long;
  GraphCount_2: Long;
  GraphCounts : T_cc_GraphCounts;
  C : Char;
begin
    l3AnalizeCharSetEx(Buf, BufEnd, OEMCount, ANSICount, GraphCount,GraphCounts);
    if (OEMCount >  ANSICount) then
      Result := l3_csOEM
    else if (GraphCount >= ANSICount) then begin
    Result := 0;
    GraphCount_2 := GraphCount div 2;
    for C := Low(T_cc_GraphCounts) to High(T_cc_GraphCounts) do begin
      If (GraphCounts[C] >  GraphCount_2) then begin
        Result := l3_csOEM;
        break;
      end;{GraphCounts[C] >  ..}
    end;{for C}
  end else Result := 0;
end;

function l3AnalizeCharSetBuf(Buf: PChar; Len: Long): Byte;
begin
  Result := l3AnalizeCharSetExEx(Buf, Buf + Len);
end;

procedure GetKLList(List: TStrings);
 var
   AList : array [0..19] of Hkl;
   AklName: array [0..255] of Char;
   i,j: Longint;
   pt:pointer;
 begin
   List.Clear;
   j:=GetKeyboardLayoutList(Sizeof(AList) div Sizeof(AList[0]), AList) - 1;
   for i := 0 to j do
     begin
       GetLocaleInfo(LoWord(AList[i]), LOCALE_SLANGUAGE, AklName, SizeOf(AklName)-1);
       pt:=Pointer(AList[i]);
       List.AddObject(AklName, pt);
     end;
 end;



end.
