unit TotalConsolePanel;

interface

uses
  SysUtils, Classes, Controls, ExtCtrls;

type
  TTotalConsolePanel = class(TPanel)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    property Canvas;
    procedure Paint; override;
  published
    { Published declarations }
  end;

procedure Register;

implementation

uses Windows,Graphics;

procedure TTotalConsolePanel.Paint;
var
  Rect,r,r2: TRect;
  TopColor, BottomColor: TColor;
  FontHeight: Integer;
  buf:array[0..255] of char;
  SelfDrawnWidth:integer;      {0=not self drawn, >0 left x pixels self drawn, <0 -> right x pixels}

const
  Alignments: array[TAlignment] of Word = (DT_LEFT, DT_RIGHT, DT_CENTER);

  procedure AdjustColors(Bevel: TPanelBevel);
  begin
    TopColor := clBtnHighlight;
    if Bevel = bvLowered then TopColor := clBtnShadow;
    BottomColor := clBtnShadow;
    if Bevel = bvLowered then BottomColor := clBtnHighlight;
  end;

begin
  Rect := GetClientRect;
  if BevelOuter <> bvNone then
  begin
    AdjustColors(BevelOuter);
    Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
  end;
  if color<>clNone then
    Frame3D(Canvas, Rect, Color, Color, BorderWidth);
  if BevelInner <> bvNone then
  begin
    AdjustColors(BevelInner);
    Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
  end;
  with Canvas do begin
    Brush.Color := Color;
    FillRect(Rect);
    Brush.Style := bsClear;
    Font := Self.Font;
    FontHeight := TextHeight('W');
    with Rect do begin
      inc(left);
      Top := ((Bottom + Top) - FontHeight) div 2;
      Bottom := Top + FontHeight;
    end;
    if caption<>'' then begin
      strpcopy(buf,Caption);
      DrawText(handle, buf, -1, Rect, (DT_EXPANDTABS or
        DT_VCENTER) or Alignments[Alignment] or DT_NOPREFIX);
    end;
  end;
end;


procedure Register;
begin
  RegisterComponents('Samples', [TTotalConsolePanel]);
end;

end.
